"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_1 = require("vue");
var composition_api_1 = require("@vue/composition-api");
var vue_app_1 = require("@nuxt/vue-app");
var fetches = new WeakMap();
var isSsrHydration = function (vm) { var _a, _b, _c; return (_c = (_b = (_a = vm.$vnode) === null || _a === void 0 ? void 0 : _a.elm) === null || _b === void 0 ? void 0 : _b.dataset) === null || _c === void 0 ? void 0 : _c.fetchKey; };
var nuxtState = process.client && window.__NUXT__;
function serverPrefetch(vm) {
    return __awaiter(this, void 0, void 0, function () {
        var err_1, attrs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Call and await on $fetch
                    vm.$fetchState = vm.$fetchState || {};
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, callFetches.call(vm)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    vm.$fetchState.error = vue_app_1.normalizeError(err_1);
                    return [3 /*break*/, 4];
                case 4:
                    vm.$fetchState.pending = false;
                    // Define an ssrKey for hydration
                    vm._fetchKey = vm.$ssrContext.nuxt.fetch.length;
                    // Add data-fetch-key on parent element of Component
                    if (!vm.$vnode.data)
                        vm.$vnode.data = {};
                    attrs = (vm.$vnode.data.attrs = vm.$vnode.data.attrs || {});
                    attrs['data-fetch-key'] = vm._fetchKey;
                    // Add to ssrContext for window.__NUXT__.fetch
                    vm.$ssrContext.nuxt.fetch.push(vm.$fetchState.error
                        ? { _error: vm.$fetchState.error }
                        : JSON.parse(JSON.stringify(vm._data)));
                    return [2 /*return*/];
            }
        });
    });
}
exports.onFetch = function (callback) {
    var _a;
    var vm = composition_api_1.getCurrentInstance();
    if (!vm)
        throw new Error('This must be called within a setup function.');
    registerCallback(vm, callback);
    composition_api_1.onServerPrefetch(serverPrefetch);
    composition_api_1.onBeforeMount(function () {
        if (!vm._hydrated) {
            return callFetches.call(vm);
        }
    });
    if (process.server || !isSsrHydration(vm))
        return;
    // Hydrate component
    vm._hydrated = true;
    vm._fetchKey = +((_a = vm.$vnode.elm) === null || _a === void 0 ? void 0 : _a.dataset.fetchKey);
    var data = nuxtState.fetch[vm._fetchKey];
    // If fetch error
    if (data && data._error) {
        vm.$fetchState.error = data._error;
        return;
    }
    composition_api_1.onBeforeMount(function () {
        // Merge data
        for (var key in data) {
            try {
                vue_1.default.set(vm, key, data[key]);
            }
            catch (e) {
                if (process.env.NODE_ENV === 'development')
                    console.warn("Could not hydrate " + key + ".");
            }
        }
    });
};
function registerCallback(vm, callback) {
    var callbacks = fetches.get(vm) || [];
    fetches.set(vm, __spreadArrays(callbacks, [callback]));
}
function callFetches() {
    return __awaiter(this, void 0, void 0, function () {
        var fetchesToCall, error, startTime, err_2, delayLeft;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fetchesToCall = fetches.get(this);
                    if (!fetchesToCall)
                        return [2 /*return*/];
                    this.$nuxt.nbFetching++;
                    this.$fetchState.pending = true;
                    this.$fetchState.error = null;
                    this._hydrated = false;
                    error = null;
                    startTime = Date.now();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, Promise.all(fetchesToCall.map(function (fetch) { return fetch(_this); }))];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_2 = _a.sent();
                    error = vue_app_1.normalizeError(err_2);
                    return [3 /*break*/, 4];
                case 4:
                    delayLeft = (this._fetchDelay || 0) - (Date.now() - startTime);
                    if (!(delayLeft > 0)) return [3 /*break*/, 6];
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, delayLeft); })];
                case 5:
                    _a.sent();
                    _a.label = 6;
                case 6:
                    this.$fetchState.error = error;
                    this.$fetchState.pending = false;
                    this.$fetchState.timestamp = Date.now();
                    this.$nextTick(function () { return _this.$nuxt.nbFetching--; });
                    return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=fetch.js.map